org.apache.xalan.xsltc.trax

## Class TransformerFactoryImpl

- java.lang.Object
- - javax.xml.transform.TransformerFactory
  - - javax.xml.transform.sax.SAXTransformerFactory
    - - org.apache.xalan.xsltc.trax.TransformerFactoryImpl

All Implemented Interfaces:
  ErrorListener, SourceLoader

    public class TransformerFactoryImpl
    extends SAXTransformerFactory
    implements SourceLoader, ErrorListener

Implementation of a JAXP1.1 TransformerFactory for Translets.

Author:
  G. Todd Miller, Morten Jorgensen, Santiago Pericas-Geertsen

### Field Summary

Fields
`static java.lang.String` `AUTO_TRANSLET`
`static java.lang.String` `DEBUG`
`static java.lang.String` `DESTINATION_DIRECTORY`
`static java.lang.String` `ENABLE_INLINING`
`static java.lang.String` `GENERATE_TRANSLET`
`static java.lang.String` `INDENT_NUMBER`
`static java.lang.String` `JAR_NAME`
`static java.lang.String` `PACKAGE_NAME`
`static java.lang.String` `TRANSLET_NAME`
`static java.lang.String` `USE_CLASSPATH`

### Fields inherited from class javax.xml.transform.sax.SAXTransformerFactory

`FEATURE, FEATURE_XMLFILTER`

### Constructor Summary

Constructors
Constructor and Description
`TransformerFactoryImpl()` javax.xml.transform.sax.TransformerFactory implementation.

### Method Summary

Methods
`void` `error(TransformerException e)` Receive notification of a recoverable error.
`void` `fatalError(TransformerException e)` Receive notification of a non-recoverable error.
`Source` `getAssociatedStylesheet(Source source, java.lang.String media, java.lang.String title, java.lang.String charset)` javax.xml.transform.sax.TransformerFactory implementation.
`java.lang.Object` `getAttribute(java.lang.String name)` javax.xml.transform.sax.TransformerFactory implementation.
`ErrorListener` `getErrorListener()` javax.xml.transform.sax.TransformerFactory implementation.
`boolean` `getFeature(java.lang.String name)` javax.xml.transform.sax.TransformerFactory implementation.
`URIResolver` `getURIResolver()` javax.xml.transform.sax.TransformerFactory implementation.
`InputSource` `loadSource(java.lang.String href, java.lang.String context, XSLTC xsltc)` This method implements XSLTC's SourceLoader interface.
`Templates` `newTemplates(Source source)` javax.xml.transform.sax.TransformerFactory implementation.
`TemplatesHandler` `newTemplatesHandler()` javax.xml.transform.sax.SAXTransformerFactory implementation.
`Transformer` `newTransformer()` javax.xml.transform.sax.TransformerFactory implementation.
`Transformer` `newTransformer(Source source)` javax.xml.transform.sax.TransformerFactory implementation.
`TransformerHandler` `newTransformerHandler()` javax.xml.transform.sax.SAXTransformerFactory implementation.
`TransformerHandler` `newTransformerHandler(Source src)` javax.xml.transform.sax.SAXTransformerFactory implementation.
`TransformerHandler` `newTransformerHandler(Templates templates)` javax.xml.transform.sax.SAXTransformerFactory implementation.
`XMLFilter` `newXMLFilter(Source src)` javax.xml.transform.sax.SAXTransformerFactory implementation.
`XMLFilter` `newXMLFilter(Templates templates)` javax.xml.transform.sax.SAXTransformerFactory implementation.
`void` `setAttribute(java.lang.String name, java.lang.Object value)` javax.xml.transform.sax.TransformerFactory implementation.
`void` `setErrorListener(ErrorListener listener)` javax.xml.transform.sax.TransformerFactory implementation.
`void` `setFeature(java.lang.String name, boolean value)` Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.
`void` `setURIResolver(URIResolver resolver)` javax.xml.transform.sax.TransformerFactory implementation.
`void` `warning(TransformerException e)` Receive notification of a warning.

### Methods inherited from class javax.xml.transform.TransformerFactory

`newInstance`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### TRANSLET_NAME

    public static final java.lang.String TRANSLET_NAME

See Also:
  Constant Field Values

#### DESTINATION_DIRECTORY

    public static final java.lang.String DESTINATION_DIRECTORY

See Also:
  Constant Field Values

#### PACKAGE_NAME

    public static final java.lang.String PACKAGE_NAME

See Also:
  Constant Field Values

#### JAR_NAME

    public static final java.lang.String JAR_NAME

See Also:
  Constant Field Values

#### GENERATE_TRANSLET

    public static final java.lang.String GENERATE_TRANSLET

See Also:
  Constant Field Values

#### AUTO_TRANSLET

    public static final java.lang.String AUTO_TRANSLET

See Also:
  Constant Field Values

#### USE_CLASSPATH

    public static final java.lang.String USE_CLASSPATH

See Also:
  Constant Field Values

#### DEBUG

    public static final java.lang.String DEBUG

See Also:
  Constant Field Values

#### ENABLE_INLINING

    public static final java.lang.String ENABLE_INLINING

See Also:
  Constant Field Values

#### INDENT_NUMBER

    public static final java.lang.String INDENT_NUMBER

See Also:
  Constant Field Values

### Constructor Detail

#### TransformerFactoryImpl

    public TransformerFactoryImpl()

javax.xml.transform.sax.TransformerFactory implementation.

### Method Detail

#### setErrorListener

    public void setErrorListener(ErrorListener listener)
                          throws java.lang.IllegalArgumentException

javax.xml.transform.sax.TransformerFactory implementation. Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.

Specified by:
  `setErrorListener` in class `TransformerFactory`
Parameters:
  `listener` - The error listener to use with the TransformerFactory
Throws:
  `java.lang.IllegalArgumentException`

#### getErrorListener

    public ErrorListener getErrorListener()

javax.xml.transform.sax.TransformerFactory implementation. Get the error event handler for the TransformerFactory.

Specified by:
  `getErrorListener` in class `TransformerFactory`
Returns:
  The error listener used with the TransformerFactory

#### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)
                                  throws java.lang.IllegalArgumentException

javax.xml.transform.sax.TransformerFactory implementation. Returns the value set for a TransformerFactory attribute

Specified by:
  `getAttribute` in class `TransformerFactory`
Parameters:
  `name` - The attribute name
Returns:
  An object representing the attribute value
Throws:
  `java.lang.IllegalArgumentException`

#### setAttribute

    public void setAttribute(java.lang.String name,
                    java.lang.Object value)
                      throws java.lang.IllegalArgumentException

javax.xml.transform.sax.TransformerFactory implementation. Sets the value for a TransformerFactory attribute.

Specified by:
  `setAttribute` in class `TransformerFactory`
Parameters:
  `name` - The attribute name
  `value` - An object representing the attribute value
Throws:
  `java.lang.IllegalArgumentException`

#### setFeature

    public void setFeature(java.lang.String name,
                  boolean value)
                    throws TransformerConfigurationException

Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.

Feature names are fully qualified `URI`s. Implementations may define their own features. An `TransformerConfigurationException` is thrown if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support the feature. It is possible for an `TransformerFactory` to expose a feature value but be unable to change its state.

See `TransformerFactory` for full documentation of specific features.

Specified by:
  `setFeature` in class `TransformerFactory`
Parameters:
  `name` - Feature name.
  `value` - Is feature state `true` or `false`.
Throws:
  `TransformerConfigurationException` - if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support this feature.
  `java.lang.NullPointerException` - If the `name` parameter is null.

#### getFeature

    public boolean getFeature(java.lang.String name)

javax.xml.transform.sax.TransformerFactory implementation. Look up the value of a feature (to see if it is supported). This method must be updated as the various methods and features of this class are implemented.

Specified by:
  `getFeature` in class `TransformerFactory`
Parameters:
  `name` - The feature name
Returns:
  'true' if feature is supported, 'false' if not

#### getURIResolver

    public URIResolver getURIResolver()

javax.xml.transform.sax.TransformerFactory implementation. Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.

Specified by:
  `getURIResolver` in class `TransformerFactory`
Returns:
  The URLResolver used for this TransformerFactory and all Templates and Transformer objects created using this factory

#### setURIResolver

    public void setURIResolver(URIResolver resolver)

javax.xml.transform.sax.TransformerFactory implementation. Set the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include. Note that this does not affect Templates and Transformers that are already created with this factory.

Specified by:
  `setURIResolver` in class `TransformerFactory`
Parameters:
  `resolver` - The URLResolver used for this TransformerFactory and all Templates and Transformer objects created using this factory

#### getAssociatedStylesheet

    public Source getAssociatedStylesheet(Source source,
                                 java.lang.String media,
                                 java.lang.String title,
                                 java.lang.String charset)
                                   throws TransformerConfigurationException

javax.xml.transform.sax.TransformerFactory implementation. Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria.

Specified by:
  `getAssociatedStylesheet` in class `TransformerFactory`
Parameters:
  `source` - The XML source document.
  `media` - The media attribute to be matched. May be null, in which case the prefered templates will be used (i.e. alternate = no).
  `title` - The value of the title attribute to match. May be null.
  `charset` - The value of the charset attribute to match. May be null.
Returns:
  A Source object suitable for passing to the TransformerFactory.
Throws:
  `TransformerConfigurationException`
See Also:
  Associating Style Sheets with XML documents Version 1.0

#### newTransformer

    public Transformer newTransformer()
                               throws TransformerConfigurationException

javax.xml.transform.sax.TransformerFactory implementation. Create a Transformer object that copies the input document to the result.

Specified by:
  `newTransformer` in class `TransformerFactory`
Returns:
  A Transformer object that simply copies the source to the result.
Throws:
  `TransformerConfigurationException`

#### newTransformer

    public Transformer newTransformer(Source source)
                               throws TransformerConfigurationException

javax.xml.transform.sax.TransformerFactory implementation. Process the Source into a Templates object, which is a a compiled representation of the source. Note that this method should not be used with XSLTC, as the time-consuming compilation is done for each and every transformation.

Specified by:
  `newTransformer` in class `TransformerFactory`
Parameters:
  `source` - `Source` of XSLT document used to create `Transformer`. Examples of XML `Source`s include `DOMSource`, `SAXSource`, and `StreamSource`.
Returns:
  A Templates object that can be used to create Transformers.
Throws:
  `TransformerConfigurationException`
See Also:
  XSL Transformations (XSLT) Version 1.0

#### newTemplates

    public Templates newTemplates(Source source)
                           throws TransformerConfigurationException

javax.xml.transform.sax.TransformerFactory implementation. Process the Source into a Templates object, which is a a compiled representation of the source.

Specified by:
  `newTemplates` in class `TransformerFactory`
Parameters:
  `source` - The input stylesheet - DOMSource not supported!!!
Returns:
  A Templates object that can be used to create Transformers.
Throws:
  `TransformerConfigurationException`

#### newTemplatesHandler

    public TemplatesHandler newTemplatesHandler()
                                         throws TransformerConfigurationException

javax.xml.transform.sax.SAXTransformerFactory implementation. Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.

Specified by:
  `newTemplatesHandler` in class `SAXTransformerFactory`
Returns:
  A TemplatesHandler object that can handle SAX events
Throws:
  `TransformerConfigurationException`

#### newTransformerHandler

    public TransformerHandler newTransformerHandler()
                                             throws TransformerConfigurationException

javax.xml.transform.sax.SAXTransformerFactory implementation. Get a TransformerHandler object that can process SAX ContentHandler events into a Result. This method will return a pure copy transformer.

Specified by:
  `newTransformerHandler` in class `SAXTransformerFactory`
Returns:
  A TransformerHandler object that can handle SAX events
Throws:
  `TransformerConfigurationException`

#### newTransformerHandler

    public TransformerHandler newTransformerHandler(Source src)
                                             throws TransformerConfigurationException

javax.xml.transform.sax.SAXTransformerFactory implementation. Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.

Specified by:
  `newTransformerHandler` in class `SAXTransformerFactory`
Parameters:
  `src` - The source of the transformation instructions.
Returns:
  A TransformerHandler object that can handle SAX events
Throws:
  `TransformerConfigurationException`

#### newTransformerHandler

    public TransformerHandler newTransformerHandler(Templates templates)
                                             throws TransformerConfigurationException

javax.xml.transform.sax.SAXTransformerFactory implementation. Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.

Specified by:
  `newTransformerHandler` in class `SAXTransformerFactory`
Parameters:
  `templates` - Represents a pre-processed stylesheet
Returns:
  A TransformerHandler object that can handle SAX events
Throws:
  `TransformerConfigurationException`

#### newXMLFilter

    public XMLFilter newXMLFilter(Source src)
                           throws TransformerConfigurationException

javax.xml.transform.sax.SAXTransformerFactory implementation. Create an XMLFilter that uses the given source as the transformation instructions.

Specified by:
  `newXMLFilter` in class `SAXTransformerFactory`
Parameters:
  `src` - The source of the transformation instructions.
Returns:
  An XMLFilter object, or null if this feature is not supported.
Throws:
  `TransformerConfigurationException`

#### newXMLFilter

    public XMLFilter newXMLFilter(Templates templates)
                           throws TransformerConfigurationException

javax.xml.transform.sax.SAXTransformerFactory implementation. Create an XMLFilter that uses the given source as the transformation instructions.

Specified by:
  `newXMLFilter` in class `SAXTransformerFactory`
Parameters:
  `templates` - The source of the transformation instructions.
Returns:
  An XMLFilter object, or null if this feature is not supported.
Throws:
  `TransformerConfigurationException`

#### error

    public void error(TransformerException e)
               throws TransformerException

Receive notification of a recoverable error. The transformer must continue to provide normal parsing events after invoking this method. It should still be possible for the application to process the document through to the end.

Specified by:
  `error` in interface `ErrorListener`
Parameters:
  `e` - The warning information encapsulated in a transformer exception.
Throws:
  `TransformerException` - if the application chooses to discontinue the transformation (always does in our case).
See Also:
  `TransformerException`

#### fatalError

    public void fatalError(TransformerException e)
                    throws TransformerException

Receive notification of a non-recoverable error. The application must assume that the transformation cannot continue after the Transformer has invoked this method, and should continue (if at all) only to collect addition error messages. In fact, Transformers are free to stop reporting events once this method has been invoked.

Specified by:
  `fatalError` in interface `ErrorListener`
Parameters:
  `e` - warning information encapsulated in a transformer exception.
Throws:
  `TransformerException` - if the application chooses to discontinue the transformation (always does in our case).
See Also:
  `TransformerException`

#### warning

    public void warning(TransformerException e)
                 throws TransformerException

Receive notification of a warning. Transformers can use this method to report conditions that are not errors or fatal errors. The default behaviour is to take no action. After invoking this method, the Transformer must continue with the transformation. It should still be possible for the application to process the document through to the end.

Specified by:
  `warning` in interface `ErrorListener`
Parameters:
  `e` - The warning information encapsulated in a transformer exception.
Throws:
  `TransformerException` - if the application chooses to discontinue the transformation (never does in our case).
See Also:
  `TransformerException`

#### loadSource

    public InputSource loadSource(java.lang.String href,
                         java.lang.String context,
                         XSLTC xsltc)

This method implements XSLTC's SourceLoader interface. It is used to glue a TrAX URIResolver to the XSLTC compiler's Input and Import classes.

Specified by:
  `loadSource` in interface `SourceLoader`
Parameters:
  `href` - The URI of the document to load
  `context` - The URI of the currently loaded document
  `xsltc` - The compiler that resuests the document
Returns:
  An InputSource with the loaded document